Bug 1477567 - Review Request: gcolor3 - A simple color chooser written in GTK3 (like gcolor2)
Review Request: gcolor3 - A simple color chooser written in GTK3 (like gcolor2)
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
: 1477568 (view as bug list)
Depends On:
Blocks: FE-NEEDSPONSOR
  Show dependency treegraph
 
Reported: 2017-08-02 07:58 EDT by Timothée Floure
Modified: 2017-08-18 08:14 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Timothée Floure 2017-08-02 07:58:40 EDT
Spec URL: http://copr-dist-git.fedorainfracloud.org/cgit/fnux/gcolor3/gcolor3.git/plain/gcolor3.spec
SRPM URL: http://files.fnux.ch/rpm/gcolor3-2.2-2.fc25.src.rpm
Description:
Gcolor3 is a color selection dialog written in GTK+ 3. It is much alike Gcolor2,
but uses the newer GTK+ version to better integrate into your modern desktop.
It has the same feature set as Gcolor2, except that recent versions of Gcolor3
use an .ini style file to save colors (older versions use the same file as
Gcolor2).

Fedora Account System Username: fnux

This is my first package submission, hence I'm looking for a sponsor.
Comment 1 Timothée Floure 2017-08-02 08:06:19 EDT
*** Bug 1477568 has been marked as a duplicate of this bug. ***
Comment 2 c72578 2017-08-03 06:27:06 EDT
Dear Timothée,
thanks for working on a Fedora rpm file of gcolor3.

Here are some initial comments:

- Please remove "Group: Development/Tools" from spec file, which is deprecated
https://fedoraproject.org/wiki/RPMGroups

- The license file has to be included separately (not under %doc)
%license LICENSE

- Could you have a look at the BuildRequires entries and possibly add minimum required versions.
What about requirement of perl? configure checks for it:
checking for perl >= 5.8.1... 5.24.2

- rpmlint shows the following error:
gcolor3.x86_64: E: invalid-appdata-file /usr/share/appdata/gcolor3.appdata.xml

When running appstream-util for validation of gcolor3.appdata.xml, I get the following output:

appstream-util validate /usr/share/appdata/gcolor3.appdata.xml
/usr/share/appdata/gcolor3.appdata.xml: FAILED:
• url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Unia/unia.github.io/hugo/static/images/projects/gcolor3/saved.png]
• url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Unia/unia.github.io/hugo/static/images/projects/gcolor3/picker.png]
Validation of files failed

This should be fixed/patched, ideally together with upstream and the screenshots saved in a "permanent" location.
Comment 3 Robert-André Mauchin 2017-08-03 06:44:50 EDT
Hello,

Quick problem:
 - LICENSE should be in %license, not %doc
 - Use %make_build instead of make %{?_smp_mflags}
 - The source file is just name v2.2.tar.gz: rename it to a more explicit name:
   Here's how to do it:

Source0: https://github.com/Hjdskes/gcolor3/archive/v2.2.tar.gz#/%{name}-%{version}.tar.gz.

 - If possible, use pkgconfig to declare -devel BR. For example pkgconfig(gtk+-3.0)

 - rpmlint fails because data/gcolor3.appdata.xml validation fails because of two 404 errors:

 gcolor3-2.2/data/gcolor3.appdata.xml: FAILED:
• url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Unia/unia.github.io/hugo/static/images/projects/gcolor3/saved.png]
• url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Unia/unia.github.io/hugo/static/images/projects/gcolor3/picker.png]
Validation of files failed

unia.github.io doesn't exist anymore. The URLs have changed to:
  - https://hjdskes.github.io/img/projects/gcolor3/saved.png
  - https://hjdskes.github.io/img/projects/gcolor3/picker.png

 Report the bug upstream or better, propose them a pull request to fix this error.
 You can also add a patch fixing it in your SPEC with a comment to the bug number, until they release a fix upstream.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later)", "Unknown or generated". 31 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/gcolor3/review-gcolor3/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in gcolor3
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     gcolor3-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gcolor3-2.2-2.fc27.x86_64.rpm
          gcolor3-debuginfo-2.2-2.fc27.x86_64.rpm
          gcolor3-2.2-2.fc27.src.rpm
gcolor3.x86_64: W: spelling-error %description -l en_US ini -> uni, in, ii
gcolor3.x86_64: W: only-non-binary-in-usr-lib
gcolor3.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
gcolor3.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
gcolor3.x86_64: W: no-manual-page-for-binary gcolor3
gcolor3.x86_64: E: invalid-appdata-file /usr/share/appdata/gcolor3.appdata.xml
gcolor3.src: W: spelling-error %description -l en_US ini -> uni, in, ii
3 packages and 0 specfiles checked; 1 errors, 6 warnings.


I'm looking for a sponsor too! You should add a "Block:" to this bug to FE-NEEDSPONSOR
Comment 4 c72578 2017-08-03 06:53:39 EDT
Just a short addition to my previous comment:
- Please ignore the part concerning perl ...
- Here is some info on the minimum required version from configure.ac concerning min version of gtk3: 
GTK_REQUIRED=3.12.0
PKG_CHECK_MODULES([GCOLOR3], [gtk+-3.0 >= GTK_REQUIRED])

- FE-NEEDSPONSOR added to this review request.
Comment 5 Michael Schwendt 2017-08-09 02:48:35 EDT
Validating the appdata file inside the spec file is a MUST, btw:
https://fedoraproject.org/wiki/Packaging:Guidelines#AppData_files
https://fedoraproject.org/wiki/Packaging:AppData#app-data-validate_usage


> [x]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "GPL (v2 or later)", "Unknown or generated". 31 files have
>      unknown license. Detailed output of licensecheck in
>      /home/bob/packaging/review/gcolor3/review-gcolor3/licensecheck.txt

Careful, here! This warning printed by fedora-review indicates that the real license may be "GPLv2+" not "GPLv2". Please double-check.
Comment 6 Timothée Floure 2017-08-17 04:41:06 EDT
Thank you for the reviews, here is an updated specfile and the related src.rpm :

* http://files.fnux.ch/bugzilla.redhat.com/1477567/2.2-3/gcolor3.spec
* http://files.fnux.ch/bugzilla.redhat.com/1477567/2.2-3/gcolor3-2.2-appdata_url.patch
* http://files.fnux.ch/bugzilla.redhat.com/1477567/2.2-3/gcolor3-2.2-3.fc26.src.rpm

About the gcolor3-2.2-appdata_url.patch, I'm not sure of what would be a 'safe' place for the screenshots (I don't consider github a 'safe' place).

Last question : should I use --nonet when validating the appdata file with appstream-util ?
Comment 7 c72578 2017-08-17 08:35:12 EDT
Storing the screenshots upstream should be OK. The issue, which you placed there is important to get this solved:
https://github.com/Hjdskes/gcolor3/issues/60

Please run the following for testing purposes, concerning your package review request:

fedora-review -b 1477567 -m fedora-rawhide-x86_64

Currently failing, see results/build.log:
...
+ appstream-util validate-relax /builddir/build/BUILDROOT/gcolor3-2.2-3.fc26.x86_64//usr/share/appdata/gcolor3.appdata.xml
/builddir/build/BUILDROOT/gcolor3-2.2-3.fc26.x86_64//usr/share/appdata/gcolor3.appdata.xml: GLib-GIO-Message: Using the 'memory' GSettings backend.  Your settings will not be saved or shared with other applications.
FAILED:
? url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Hjdskes/gcolor3/0d41086dd845e3ed01f04511902aae2e84c836f1/saved.png]
? url-not-found         : <screenshot> url not found [https://raw.githubusercontent.com/Hjdskes/gcolor3/0d41086dd845e3ed01f04511902aae2e84c836f1/picker.png]
Validation of files failed
...

However, the links to the images are OK ...
Comment 8 Fabio Valentini 2017-08-17 08:44:28 EDT
This is because the mock environment has no internet access. You have to pass the "--nonet" option to appstream-util (see Appdata packaging guidelines) to skip checks that require internet access.
Comment 9 c72578 2017-08-17 08:47:23 EDT
If you add --nonet, then it is OK:
...
+ appstream-util validate-relax --nonet /builddir/build/BUILDROOT/gcolor3-2.2-4.fc27.x86_64//usr/share/appdata/gcolor3.appdata.xml
/builddir/build/BUILDROOT/gcolor3-2.2-4.fc27.x86_64//usr/share/appdata/gcolor3.appdata.xml: GLib-GIO-Message: Using the 'memory' GSettings backend.  Your settings will not be saved or shared with other applications.
OK
...
Comment 10 c72578 2017-08-18 03:49:01 EDT
Here is a minor comment concerning the changelog:
Please add an empty line between each entry.
See example eject here:  https://fedoraproject.org/wiki/How_to_create_an_RPM_package#eject
Comment 11 Michael Schwendt 2017-08-18 08:14:20 EDT
> Last question : should I use --nonet when validating the appdata file
> with appstream-util ?

Well, that's what the previously mentioned page in the Wiki tells:
https://fedoraproject.org/wiki/Packaging:AppData#app-data-validate_usage

Note You need to log in before you can comment on or make changes to this bug.